aboutsummaryrefslogtreecommitdiffstats
path: root/rc.d/rc.sysinit
diff options
context:
space:
mode:
Diffstat (limited to 'rc.d/rc.sysinit')
-rwxr-xr-xrc.d/rc.sysinit709
1 files changed, 609 insertions, 100 deletions
diff --git a/rc.d/rc.sysinit b/rc.d/rc.sysinit
index f8f701af..b4779b18 100755
--- a/rc.d/rc.sysinit
+++ b/rc.d/rc.sysinit
@@ -7,11 +7,19 @@
HOSTNAME=$(/bin/hostname)
+. /etc/init.d/functions
+
set -m
if [ -f /etc/sysconfig/network ]; then
. /etc/sysconfig/network
fi
+
+# Read in config data.
+if [ -f /etc/sysconfig/system ]; then
+ . /etc/sysconfig/system
+fi
+
if [ -z "$HOSTNAME" -o "$HOSTNAME" = "(none)" ]; then
HOSTNAME=localhost
fi
@@ -20,16 +28,131 @@ if [ ! -e /proc/mounts ]; then
mount -n -t proc /proc /proc
mount -n -t sysfs /sys /sys >/dev/null 2>&1
fi
+
+PLYMOUTH=
+[ -x /bin/plymouth ] && PLYMOUTH=yes
+
+
+# Only read this once.
+cmdline=$(cat /proc/cmdline)
+
+for t in $cmdline; do
+ case $t in
+ -s|single|S|s) REQUESTED_RUNLEVEL="S" ;;
+ [1-9]) REQUESTED_RUNLEVEL="$t" ;;
+ esac
+done
+[ -z "$REQUESTED_RUNLEVEL" ] && REQUESTED_RUNLEVEL=$(/bin/awk -F ':' '$3 == "initdefault" && $1 !~ "^#" { print $2 }' /etc/inittab)
+[ -z "$REQUESTED_RUNLEVEL" ] && REQUESTED_RUNLEVEL="3"
+
+# killing splash when using single-user mode
+if [ "$REQUESTED_RUNLEVEL" == "S" ]; then
+ [ -n "$PLYMOUTH" ] && /bin/plymouth quit 2>/dev/null
+fi
+
+uname_r=`uname -r`
+
+# Read in config data.
+if [ -f /etc/sysconfig/speedboot ]; then
+ . /etc/sysconfig/speedboot
+fi
+
+if strstr "$cmdline" speedboot= ; then
+ for arg in $cmdline ; do
+ if [ "${arg##speedboot=}" != "${arg}" ]; then
+ SPEEDBOOT=${arg##speedboot=}
+ fi
+ done
+fi
+
+if [ "$REQUESTED_RUNLEVEL" != 5 -o -f /etc/rc.d/rc5.d/S*network-auth -o -f /etc/crypttab ]; then
+ SPEEDBOOT=no
+fi
+
+# disable speedboot if more than one profile is found (and not selected in cmdline)
+if echo /etc/netprofile/profiles/* | grep -q ' ' ; then
+ if ! strstr "$cmdline" PROFILE= ; then
+ SPEEDBOOT=no
+ fi
+fi
+
+if strstr "$cmdline" failsafe ; then
+ SPEEDBOOT=no
+fi
+
+# Check if a possible DKMS display driver is queued to be built on this boot
+# or an interfering driver was loaded by initrd.
+if [ "$SPEEDBOOT" != "no" ] && [ -x /sbin/display_driver_helper ] && ! /sbin/display_driver_helper --check-speedboot; then
+ SPEEDBOOT=no
+fi
+
+if [ "$SPEEDBOOT" = "probe" ]; then
+ SPEEDBOOT_PROBE=yes
+fi
+
+if [ "x$SPEEDBOOT" = "xauto" ]; then
+ STATUS=`grep -m 1 "$uname_r" /var/lib/speedboot/status 2>/dev/null`
+ case "$STATUS" in
+ *first\ time*) SPEEDBOOT=yes ;;
+ *FAILED*) SPEEDBOOT=no ;;
+ *OK*) SPEEDBOOT=yes ;;
+ *STANDARD\ BOOT*) SPEEDBOOT=yes ;;
+ *) SPEEDBOOT=no ;;
+ esac
+fi
+
+if [ "$SPEEDBOOT" = "yes" ]; then
+ export SPEEDBOOT
+ PROMPT=no
+else
+ unset SPEEDBOOT
+fi
+
+if [ "x$SPEEDBOOT" != "xyes" ]; then
if [ ! -d /proc/bus/usb ]; then
- modprobe usbcore >/dev/null 2>&1 && mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+ modprobe usbcore >/dev/null 2>&1 && mount -n -t usbfs -o devmode=0664,devgid=43 /proc/bus/usb /proc/bus/usb
else
- mount -n -t usbfs /proc/bus/usb /proc/bus/usb
+ mount -n -t usbfs -o devmode=0664,devgid=43 /proc/bus/usb /proc/bus/usb
fi
+fi #SPEEDBOOT
-. /etc/init.d/functions
+if [ -f /.readahead_collect -a -r /etc/sysconfig/readahead ]; then
+ . /etc/sysconfig/readahead
+ if [ "x$READAHEAD_COLLECT" == "xyes" -a ! -f /forcefsck -a -x /sbin/readahead-collector ]; then
+ /sbin/readahead-collector
+ fi
+elif [ -x /sbin/readahead_early ]; then
+ /sbin/readahead_early > /dev/null 2>&1
+fi
+
+if [ -x /etc/rc.early.local ]; then
+ . /etc/rc.early.local
+fi
-PLYMOUTH=
-[ -x /usr/bin/plymouth ] && PLYMOUTH=yes
+# Unmount the initrd, if necessary
+# (pixel) do not unmount if /initrd/loopfs is mounted (happens for root loopback)
+# (bluca) handle udev /dev tmpfs here since kernel will happily umount /dev after initrd end
+# (blino) do it before the udev service is started so that it uses the /dev tmpfs from initrd
+if LC_ALL=C grep -q /initrd /proc/mounts && ! LC_ALL=C grep -q /initrd/loopfs /proc/mounts ; then
+ if LC_ALL=C grep -q /initrd/dev /proc/mounts; then
+ mount --move /initrd/dev /dev
+ fi
+ action "Unmounting initrd: " umount -l /initrd
+ /sbin/blockdev --flushbufs /dev/ram0 >/dev/null 2>&1
+fi
+
+if [ "x$SPEEDBOOT" = "xyes" ]; then
+ /sbin/start_udev
+ udevadm trigger --action=add --subsystem-match=pci --attr-match=class="0x0c03*"
+ udevadm trigger --action=add --subsystem-match=block
+ udevadm settle &
+ UDEV_DISK_PID=$!
+ udevadm trigger --action=add --subsystem-match=mem --subsystem-match=input --subsystem-match=tty --subsystem-match=acpi --subsystem-match=rtc --subsystem-match=hid
+ udevadm trigger --action=add --subsystem-match=pci --attr-match=class="0x060000*"
+ udevadm trigger --action=add --subsystem-match=pci --attr-match=class="0x03*"
+ udevadm settle &
+ UDEV_PID=$!
+fi
# Check SELinux status
SELINUX_STATE=
@@ -47,9 +170,9 @@ if [ -n "$SELINUX_STATE" ] && [ -x /sbin/restorecon ] && __fgrep " /dev " /proc/
fi
disable_selinux() {
- echo $"*** Warning -- SELinux is active"
- echo $"*** Disabling security enforcement for system recovery."
- echo $"*** Run 'setenforce 1' to reenable."
+ gprintf "*** Warning -- SELinux is active\n"
+ gprintf "*** Disabling security enforcement for system recovery.\n"
+ gprintf "*** Run 'setenforce 1' to reenable.\n"
echo "0" > "/selinux/enforce"
}
@@ -63,50 +186,57 @@ relabel_selinux() {
if [ "$AUTORELABEL" = "0" ]; then
echo
- echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required. "
- echo $"*** /etc/selinux/config indicates you want to manually fix labeling"
- echo $"*** problems. Dropping you to a shell; the system will reboot"
- echo $"*** when you leave the shell."
+ gprintf "*** Warning -- SELinux %s policy relabel is required. \n" ${SELINUXTYPE}
+ gprintf "*** /etc/selinux/config indicates you want to manually fix labeling\n"
+ gprintf "*** problems. Dropping you to a shell; the system will reboot\n"
+ gprintf "*** when you leave the shell.\n"
sulogin
else
echo
- echo $"*** Warning -- SELinux ${SELINUXTYPE} policy relabel is required."
- echo $"*** Relabeling could take a very long time, depending on file"
- echo $"*** system size and speed of hard drives."
+ gprintf "*** Warning -- SELinux %s policy relabel is required.\n" ${SELINUXTYPE}
+ gprintf "*** Relabeling could take a very long time, depending on file\n"
+ gprintf "*** system size and speed of hard drives.\n"
/sbin/fixfiles -F restore > /dev/null 2>&1
fi
rm -f /.autorelabel
- echo $"Unmounting file systems"
+ gprintf "Unmounting file systems\n"
umount -a
mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
+ gprintf "Automatic reboot in progress.\n"
reboot -f
}
# Print a text banner.
-echo -en $"\t\tWelcome to "
-read -r system_release < /etc/system-release
-if [[ "$system_release" == *"Red Hat"* ]]; then
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;31m"
- echo -en "Red Hat"
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
- PRODUCT=$(sed "s/Red Hat \(.*\) release.*/\1/" /etc/system-release)
- echo " $PRODUCT"
-elif [[ "$system_release" == *Fedora* ]]; then
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;34m"
- echo -en "Fedora"
- [ "$BOOTUP" = "color" ] && echo -en "\\033[0;39m"
- PRODUCT=$(sed "s/Fedora \(.*\) \?release.*/\1/" /etc/system-release)
- echo " $PRODUCT"
+# C-like escape sequences don't work as 2nd and up parameters of gprintf,
+# so real escap chars were written
+PRODUCT=`sed "s/.*release \([0-9.]*\).*/\1/g" /etc/mandriva-release 2> /dev/null`
+SYSTEM=${SYSTEM="Mandriva Linux"}
+
+if [ -r /etc/sysconfig/oem ]; then
+ . /etc/sysconfig/oem
+fi
+
+if [ "$BOOTUP" != "serial" ]; then
+ gprintf "\t\t\tWelcome to %s" "`echo -en '\\033[1;36m'`$SYSTEM`echo -en '\\033[0;39m'` $PRODUCT"
else
- PRODUCT=$(sed "s/ release.*//g" /etc/system-release)
- echo "$PRODUCT"
+ gprintf "\t\t\tWelcome to %s" "$SYSTEM $PRODUCT"
+fi
+echo -en "\r"
+echo
+if [ "$PROMPT" != "no" ]; then
+ gprintf "\t\tPress 'I' to enter interactive startup."
+ echo
fi
-# Only read this once.
-cmdline=$(cat /proc/cmdline)
+# Fix console loglevel
+if [ -n "$LOGLEVEL" ]; then
+ /bin/dmesg -n $LOGLEVEL
+fi
+
+initsplash 5
+rc_splash start 1
# Initialize hardware
if [ -f /proc/sys/kernel/modprobe ]; then
@@ -134,7 +264,9 @@ fi
nashpid=$(pidof nash 2>/dev/null)
[ -n "$nashpid" ] && kill $nashpid >/dev/null 2>&1
unset nashpid
-/sbin/start_udev
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+ /sbin/start_udev
+fi #SPEEDBOOT
# Load other user-defined modules
for file in /etc/sysconfig/modules/*.modules ; do
@@ -143,12 +275,19 @@ done
# Load modules (for backward compatibility with VARs)
if [ -f /etc/rc.modules ]; then
+ if [ "x$SPEEDBOOT" != "xyes" ]; then
/etc/rc.modules
+ else
+ ionice -c 3 /etc/rc.modules &
+ MODULES_PID=$!
+ fi
fi
-mount -n /dev/pts >/dev/null 2>&1
+mount -n -t devpts -o mode=620 none /dev/pts >/dev/null 2>&1
[ -n "$SELINUX_STATE" ] && restorecon /dev/pts >/dev/null 2>&1
+mount -n -t tmpfs none /dev/shm >/dev/null 2>&1
+
# Configure kernel parameters
update_boot_stage RCkernelparam
sysctl -e -p /etc/sysctl.conf >/dev/null 2>&1
@@ -157,18 +296,55 @@ for file in /etc/sysctl.d/* ; do
test -f "$file" && sysctl -e -p "$file" >/dev/null 2>&1
done
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+
+# If brltty exist start it (after udev so that vcsa device nodes are created)
+[ -x /bin/brltty -a "$BRLTTY" != "no" ] && action "Starting braille terminal" /bin/brltty && SPEEDBOOT="DISABLED reason: braille"
+
+fi #SPEEDBOOT
+
# Set the hostname.
update_boot_stage RChostname
-action $"Setting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
+action "Setting hostname %s: " ${HOSTNAME} hostname ${HOSTNAME}
+# Set the NIS domain name
+if [ -n "$NISDOMAIN" ]; then
+ action "Setting NIS domain name %s: " $NISDOMAIN nisdomainname $NISDOMAIN
+fi
+
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+# Now that we load only one scsi_hostadapter in the initrd, we
+# need to load the others here
+modprobe scsi_hostadapter >/dev/null 2>&1
+# Now that we use modular IDE, we need to do the same for IDE controllers
+modprobe ide-controller >/dev/null 2>&1
# Sync waiting for storage.
{ rmmod scsi_wait_scan ; modprobe scsi_wait_scan ; rmmod scsi_wait_scan ; } >/dev/null 2>&1
+# Start any MD RAID arrays that haven't been started yet
+if [ -f /etc/mdadm.conf -a -x /sbin/mdadm ]; then
+ MDADM_RETURN=`/sbin/mdadm -As --auto=yes --run 2>&1`
+ RETVAL=$?
+ if [ $RETVAL -gt 0 ]; then
+ echo $MDADM_RETURN | grep -q 'No arrays found in config file'
+ RETVAL=$?
+ # only enable speedboot if no array is configured
+ if [ $RETVAL -gt 0 ]; then
+ SPEEDBOOT="DISABLED: reason:MD RAID"
+ fi
+ else # MD RAID arrays detected, better to disable speedboot
+ SPEEDBOOT="DISABLED: reason:MD RAID"
+
+ fi
+fi
+fi #SPEEDBOOT
+
# Device mapper & related initialization
if ! __fgrep "device-mapper" /proc/devices >/dev/null 2>&1 ; then
modprobe dm-mod >/dev/null 2>&1
fi
+if [ "x$SPEEDBOOT" != "xyes" ]; then
if [ -f /etc/crypttab ]; then
init_crypto 0
fi
@@ -184,29 +360,31 @@ fi
if ! strstr "$cmdline" nodmraid && [ -x /sbin/dmraid ]; then
modprobe dm-mirror >/dev/null 2>&1
- dmraidsets=$(LC_ALL=C /sbin/dmraid -s -c -i)
- if [ "$?" = "0" ]; then
- for dmname in $dmraidsets; do
- if [[ "$dmname" == isw_* ]] && \
- ! strstr "$cmdline" noiswmd; then
- continue
- fi
- /sbin/dmraid -ay -i --rm_partitions -p "$dmname" >/dev/null 2>&1
- /sbin/kpartx -a -p p "/dev/mapper/$dmname"
- done
+ dmraidsets=$(LC_ALL=C /sbin/dmraid -s -c -i)
+ if [ "$dmraidsets" != "no raid disks" -a "$dmraidsets" != "no block devices found" ]; then
+ for dmname in $dmraidsets; do
+ if [[ "$dmname" =~ '^isw_.*' ]] && \
+ ! strstr "$cmdline" noiswmd; then
+ continue
+ fi
+
+ /sbin/dmraid -ay -i --rm_partitions -p "$dmname" >/dev/null 2>&1
+ /sbin/kpartx -a -p p "/dev/mapper/$dmname"
+ SPEEDBOOT="DISABLED reason:dmraid"
+ done
+ fi
fi
-fi
-
-# Start any MD RAID arrays that haven't been started yet
-[ -r /proc/mdstat -a -r /dev/md/md-device-map ] && /sbin/mdadm -IRs
-
+fi #SPEEDBOOT
+
if [ -x /sbin/lvm ]; then
- action $"Setting up Logical Volume Management:" /sbin/lvm vgchange -a y --sysinit
+ action "Setting up Logical Volume Management:" /sbin/lvm vgchange -a y --ignorelockingfailure
fi
+if [ "x$SPEEDBOOT" != "xyes" ]; then
if [ -f /etc/crypttab ]; then
init_crypto 0
fi
+fi #SPEEDBOOT
if [ -f /fastboot ] || strstr "$cmdline" fastboot ; then
fastboot=yes
@@ -216,19 +394,22 @@ if [ -f /fsckoptions ]; then
fsckoptions=$(cat /fsckoptions)
fi
+# (blino) always source autofsck settings, for AUTOFSCK_CRYPTO_TIMEOUT (#16029)
+[ -f /etc/sysconfig/autofsck ] && . /etc/sysconfig/autofsck
+
if [ -f /forcefsck ] || strstr "$cmdline" forcefsck ; then
fsckoptions="-f $fsckoptions"
elif [ -f /.autofsck ]; then
- [ -f /etc/sysconfig/autofsck ] && . /etc/sysconfig/autofsck
if [ "$AUTOFSCK_DEF_CHECK" = "yes" ]; then
AUTOFSCK_OPT="$AUTOFSCK_OPT -f"
fi
if [ -n "$AUTOFSCK_SINGLEUSER" ]; then
[ -n "$PLYMOUTH" ] && plymouth --hide-splash
+ rc_splash verbose
echo
- echo $"*** Warning -- the system did not shut down cleanly. "
- echo $"*** Dropping you to a shell; the system will continue"
- echo $"*** when you leave the shell."
+ gprintf "*** Warning -- the system did not shut down cleanly. \n"
+ gprintf "*** Dropping you to a shell; the system will continue\n"
+ gprintf "*** when you leave the shell.\n"
[ -n "$SELINUX_STATE" ] && echo "0" > /selinux/enforce
sulogin
[ -n "$SELINUX_STATE" ] && echo "1" > /selinux/enforce
@@ -398,52 +579,51 @@ _RUN_QUOTACHECK=0
if strstr "$cmdline" forcequotacheck || [ -f /forcequotacheck ] ; then
_RUN_QUOTACHECK=1
fi
-if [ -z "$fastboot" -a "$READONLY" != "yes" ]; then
-
- STRING=$"Checking filesystems"
- echo $STRING
- fsck -T -t noopts=_netdev -A $fsckoptions
+Fsck()
+{
+ fsck $*
rc=$?
if [ "$rc" -eq "0" ]; then
- success "$STRING"
+ echo_success
echo
elif [ "$rc" -eq "1" ]; then
- passed "$STRING"
+ echo_passed
echo
+ _RUN_QUOTACHECK=1
elif [ "$rc" -eq "2" -o "$rc" -eq "3" ]; then
- echo $"Unmounting file systems"
+ gprintf "Unmounting file systems\n"
umount -a
mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
+ gprintf "Automatic reboot in progress.\n"
reboot -f
- fi
-
- # A return of 4 or higher means there were serious problems.
- if [ $rc -gt 1 ]; then
- [ -n "$PLYMOUTH" ] && plymouth --hide-splash
-
- failure "$STRING"
+ elif [ $((rc & 4)) = 4 ]; then
+ # Return code is a or between return codes for the filesystems
+ # 4 means that a filesystem remains corrupted
+ rc_splash verbose
+ echo_failure
echo
echo
- echo $"*** An error occurred during the file system check."
- echo $"*** Dropping you to a shell; the system will reboot"
- echo $"*** when you leave the shell."
+ gprintf "*** An error occurred during the file system check.\n"
+ gprintf "*** Dropping you to a shell; the system will reboot\n"
+ gprintf "*** when you leave the shell.\n"
- str=$"(Repair filesystem)"
+ str=`gprintf "(Repair filesystem)"`
PS1="$str \# # "; export PS1
[ "$SELINUX_STATE" = "1" ] && disable_selinux
sulogin
- echo $"Unmounting file systems"
+ gprintf "Unmounting file systems\n"
umount -a
mount -n -o remount,ro /
- echo $"Automatic reboot in progress."
+ gprintf "Automatic reboot in progress.\n"
reboot -f
- elif [ "$rc" -eq "1" ]; then
- _RUN_QUOTACHECK=1
+ else
+ echo_failure
+ echo
+ gprintf "*** A non fatal error occurred during the file system check.\n"
fi
-fi
+}
remount_needed() {
local state oldifs
@@ -461,23 +641,53 @@ remount_needed() {
return 0
}
+if [ "x$SPEEDBOOT" = "xyes" ]; then
+ wait $UDEV_DISK_PID
+fi
+# do not check / if already rw (for example with unionfs)
+if [ -z "$fastboot" -a "$READONLY" != "yes" ] && remount_needed; then
+ gprintf "Checking root filesystem\n"
+ Fsck -T -a $fsckoptions /
+fi
+_RUN_QUOTACHECK=0
+
# Remount the root filesystem read-write.
update_boot_stage RCmountfs
if remount_needed ; then
- action $"Remounting root filesystem in read-write mode: " mount -n -o remount,rw /
+ action "Remounting root filesystem in read-write mode: " mount -n -o remount,rw /
+fi
+
+# wait for usb storage scanning processes to finish
+if ! strstr "$cmdline" nousb; then
+ LC_ALL=C grep '08' /sys/bus/usb/devices/*/bInterfaceClass >/dev/null 2>&1
+ RETVAL=$?
+ if [ $RETVAL -eq 0 ]; then
+ countdown=20
+ until [ -d /sys/module/usb_storage -o $countdown -eq 0 ]; do
+ usleep 100000; let countdown=$countdown-1;
+ done
+ while ps -eocomm | grep -q usb-stor-scan; do
+ sleep 1;
+ done
+ fi
fi
+if [ "x$SPEEDBOOT" != "xyes" ]; then
# Clean up SELinux labels
if [ -n "$SELINUX_STATE" ]; then
restorecon /etc/mtab /etc/ld.so.cache /etc/blkid/blkid.tab /etc/resolv.conf >/dev/null 2>&1
+ SPEEDBOOT="DISABLED reason: SELinux"
fi
+[ -x /sbin/hibernate-cleanup.sh ] && /sbin/hibernate-cleanup.sh start
+
# If relabeling, relabel mount points.
if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
restorecon $(awk '!/^#/ && $4 !~ /noauto/ && $2 ~ /^\// { print $2 }' /etc/fstab) >/dev/null 2>&1
fi
fi
+fi
if [ "$READONLY" != "yes" ] ; then
# Clear mtab
@@ -494,25 +704,109 @@ if [ "$READONLY" != "yes" ] ; then
mount -f /dev/shm >/dev/null 2>&1
mount -f /proc/bus/usb >/dev/null 2>&1
fi
+# (pixel) also added /initrd/loopfs for loopback root
+mount -f /initrd/loopfs 2>/dev/null
-# Mount all other filesystems (except for NFS and /proc, which is already
+if [ -x /sbin/isapnp -a -f /etc/isapnp.conf -a ! -f /proc/isapnp ]; then
+ # check for arguments passed from kernel
+ if ! strstr "$cmdline" nopnp ; then
+ PNP=yes
+ fi
+ if [ -n "$PNP" ]; then
+ action "Setting up ISA PNP devices: " /sbin/isapnp /etc/isapnp.conf
+ else
+ action "Skipping ISA PNP configuration at users request: " /bin/true
+ fi
+fi
+
+# tweak isapnp settings if needed.
+if [ -n "$PNP" -a -f /proc/isapnp -a -x /sbin/sndconfig ]; then
+ /sbin/sndconfig --mungepnp >/dev/null 2>&1
+fi
+
+# Check filesystems
+# (pixel) do not check loopback files, will be done later (aren't available yet)
+if [ -z "$fastboot" ]; then
+ gprintf "Checking filesystems\n"
+ Fsck -T -R -A -a -t noopts=loop $fsckoptions
+fi
+
+# Mount all other filesystems (except for network bases filesystems and /proc, which is already
# mounted). Contrary to standard usage,
# filesystems are NOT unmounted in single user mode.
+# (pixel) also do not mount loopback and encrypted filesystems
+# will be done later
+(
+# export locales (needed by mount.ntfs-3g)
+export LC_ALL
+export LANG
if [ "$READONLY" != "yes" ] ; then
- action $"Mounting local filesystems: " mount -a -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+ action "Mounting local filesystems: " mount -a -t nodevpts,nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev,noloop,noencrypted
else
- action $"Mounting local filesystems: " mount -a -n -t nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev
+ action "Mounting local filesystems: " mount -a -n -t nodevpts,nonfs,nfs4,smbfs,ncpfs,cifs,gfs,gfs2 -O no_netdev,noloop,noencrypted
+fi
+)
+
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+[[ -z $AUTOFSCK_CRYPTO_TIMEOUT ]] && AUTOFSCK_CRYPTO_TIMEOUT=15
+
+#Mounting Encrypted filesystem
+encrypted_swap=
+if [[ ! -f /fastboot ]];then
+ encrypted=
+ while read -a entry;do
+ device=${entry[0]}
+ mountpoint=${entry[1]}
+ options=${entry[3]}
+ type=${entry[2]}
+ if [[ $options == *encryption=* || $options == *encrypted* ]];then
+ [[ $options == *noauto* ]] && continue
+ if [[ $type == *swap* ]];then
+ encrypted_swap="$encrypted_swap $device"
+ continue
+ fi
+ encrypted="$encrypted $mountpoint"
+ fi
+ done < /etc/fstab
+ if [[ -n $encrypted ]];then
+ modprobe cryptoloop
+ rc_splash verbose
+ echo "We have discovered Encrypted filesystems, do you want to mount them now ?"
+ MSG=`gprintf "Press Y within %%d seconds to mount your encrypted filesystems..."`
+ KEYS=`gprintf "yY"`
+ if /sbin/getkey -c $AUTOFSCK_CRYPTO_TIMEOUT -m "$MSG" "$KEYS"; then
+ echo -e '\n'
+ for i in ${encrypted};do
+ echo -n "${i} "; mount ${i}
+ done
+ else
+ echo -e '\n'
+ fi
+ fi
fi
+# (pixel) Check loopback filesystems
+if [ ! -f /fastboot ]; then
+ modprobe loop
+ gprintf "Checking loopback filesystems"
+ Fsck -T -R -A -a -t opts=loop $fsckoptions
+fi
+
+fi #SPEEDBOOT
+
+# Mount loopback
+action "Mounting loopback filesystems: " mount -a -O loop
+
# Update quotas if necessary
if [ X"$_RUN_QUOTACHECK" = X1 ] && [ -x /sbin/quotacheck ]; then
- action $"Checking local filesystem quotas: " /sbin/quotacheck -anug
+ action "Checking local filesystem quotas: " /sbin/quotacheck -anug
fi
if [ -x /sbin/quotaon ]; then
- action $"Enabling local filesystem quotas: " /sbin/quotaon -aug
+ action "Turning on user and group quotas for local filesystems: " /sbin/quotaon -aug
fi
+if [ "x$SPEEDBOOT" != "xyes" ]; then
# Check to see if a full relabel is needed
if [ -n "$SELINUX_STATE" -a "$READONLY" != "yes" ]; then
if strstr "$cmdline" autorelabel || [ -f /.autorelabel ] ; then
@@ -523,6 +817,7 @@ else
[ -f /.autorelabel ] || touch /.autorelabel
fi
fi
+fi #SPEEDBOOT
# Initialize pseudo-random number generator
if [ -f "/var/lib/random-seed" ]; then
@@ -534,9 +829,10 @@ if [ "$READONLY" != "yes" ]; then
chmod 600 /var/lib/random-seed
dd if=/dev/urandom of=/var/lib/random-seed count=1 bs=512 2>/dev/null
fi
-
+if [ "x$SPEEDBOOT" != "xyes" ]; then
if [ -f /etc/crypttab ]; then
init_crypto 1
+ SPEEDBOOT="DISABLED reason: crypto FS"
fi
# Configure machine if necessary.
@@ -570,15 +866,21 @@ if [ -f /.unconfigured ]; then
. /etc/sysconfig/network
# Reset the hostname.
- action $"Resetting hostname ${HOSTNAME}: " hostname ${HOSTNAME}
+ action "Resetting hostname %s: " ${HOSTNAME} hostname ${HOSTNAME}
+
+ # Reset the NIS domain name.
+ if [ -n "$NISDOMAIN" ]; then
+ action "Resetting NIS domain name %s: " $NISDOMAIN nisdomainname $NISDOMAIN
+ fi
fi
rm -f /.unconfigured
fi
+fi
# Clean out /.
rm -f /fastboot /fsckoptions /forcefsck /.autofsck /forcequotacheck /halt \
- /poweroff /.suspended &> /dev/null
+ /poweroff /.suspended /etc/killpower &> /dev/null
# Do we need (w|u)tmpx files? We don't set them up, but the sysadmin might...
_NEED_XFILES=
@@ -586,10 +888,15 @@ _NEED_XFILES=
# Clean up /var.
rm -rf /var/lock/cvs/* /var/run/screen/*
-find /var/lock /var/run ! -type d -exec rm -f {} \;
-rm -f /var/lib/rpm/__db* &> /dev/null
-rm -f /var/gdm/.gdmfifo &> /dev/null
+find /var/lock /var/run ! -type d ! -path '/var/lock/TMP_1ST' -exec rm -f {} \;
+if [ "x$SPEEDBOOT" = "xyes" ]; then
+ wait $MODULES_PID
+ wait $UDEV_PID
+ /etc/rc.d/rc S &
+ RC_PID=$!
+fi
+{
# Clean up utmp/wtmp
> /var/run/utmp
touch /var/log/wtmp /var/log/btmp
@@ -606,11 +913,12 @@ fi
# Clean up various /tmp bits
[ -n "$SELINUX_STATE" ] && restorecon /tmp
-rm -f /tmp/.X*-lock /tmp/.lock.* /tmp/.gdm_socket /tmp/.s.PGSQL.*
+rm -f /tmp/.X*-lock /tmp/.lock.* /tmp/.s.PGSQL.*
rm -rf /tmp/.X*-unix /tmp/.ICE-unix /tmp/.font-unix /tmp/hsperfdata_* \
/tmp/kde-* /tmp/ksocket-* /tmp/mc-* /tmp/mcop-* /tmp/orbit-* \
- /tmp/scrollkeeper-* /tmp/ssh-* \
- /dev/.in_sysinit
+ /tmp/ssh-* /tmp/.fam_socket /tmp/.esd /tmp/.esd-* \
+ /tmp/pulse-* /tmp/.sawfish-* /tmp/esrv* /tmp/kio* \
+ /var/lib/gdm/core.*
# Make ICE directory
mkdir -m 1777 -p /tmp/.ICE-unix >/dev/null 2>&1
@@ -619,7 +927,7 @@ chown root:root /tmp/.ICE-unix
# Start up swapping.
update_boot_stage RCswap
-action $"Enabling /etc/fstab swaps: " swapon -a -e
+action "Enabling /etc/fstab swaps: " swapon -a -e 2>/dev/null
if [ "$AUTOSWAP" = "yes" ]; then
curswap=$(awk '/^\/dev/ { print $1 }' /proc/swaps | while read x; do get_numeric_dev dec $x ; echo -n " "; done)
swappartitions=$(blkid -t TYPE=swap -o device)
@@ -627,7 +935,7 @@ if [ "$AUTOSWAP" = "yes" ]; then
for partition in $swappartitions ; do
[ ! -e $partition ] && continue
majmin=$(get_numeric_dev dec $partition)
- echo $curswap | grep -qw "$majmin" || action $"Enabling local swap partitions: " swapon $partition
+ echo $curswap | grep -qw "$majmin" || action "Enabling local swap partitions: " swapon $partition
done
fi
fi
@@ -646,20 +954,221 @@ if [ -x /usr/sbin/system-config-network-cmd ]; then
fi
fi
+(
+# Now turn on swap in case we swap to files.
+action "Enabling swap space: " swapon -a -e
+
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+# If a SCSI tape has been detected, load the st module unconditionally
+# since many SCSI tapes don't deal well with st being loaded and unloaded
+if [ -n "$USEMODULES" -a -f /proc/scsi/scsi ] && LC_ALL=C grep -q 'Type: Sequential-Access' /proc/scsi/scsi 2>/dev/null ; then
+ LC_ALL=C fgrep -q ' 9 st' /proc/devices || modprobe st >/dev/null 2>&1
+ SPEEDBOOT="DISABLED reason: SCSI tape"
+fi
+fi #SPEEDBOOT
+
+(
+# Turn on harddisk optimization
+# There is only one file /etc/sysconfig/harddisks for all disks
+# after installing the hdparm-RPM. If you need different hdparm parameters
+# for each of your disks, copy /etc/sysconfig/harddisks to
+# /etc/sysconfig/harddiskhda (hdb, hdc...) and modify it.
+# Each disk which has no special parameters will use the defaults.
+# Each non-disk which has no special parameters will be ignored.
+#
+
+disk[0]=s;
+disk[1]=hda; disk[2]=hdb; disk[3]=hdc; disk[4]=hdd;
+disk[5]=hde; disk[6]=hdf; disk[7]=hdg; disk[8]=hdh;
+disk[9]=hdi; disk[10]=hdj; disk[11]=hdk; disk[12]=hdl;
+disk[13]=hdm; disk[14]=hdn; disk[15]=hdo; disk[16]=hdp;
+disk[17]=hdq; disk[18]=hdr; disk[19]=hds; disk[20]=hdt;
+disk[21]=sda; disk[22]=sdb; disk[23]=sdc; disk[24]=sdd;
+disk[25]=sde; disk[26]=sdf; disk[27]=sdg; disk[28]=sdh;
+disk[29]=sr0; disk[30]=sr1; disk[31]=sr2; disk[32]=sr3;
+disk[33]=scd0; disk[34]=scd1; disk[35]=scd2; disk[36]=scd3;
+disk[37]=sg0; disk[38]=sg1; disk[39]=sg2; disk[40]=sg3;
+
+
+# Skip hard disks optimization if software RAID arrays are currently
+# resyncing and disks heavily active, because hdparm might hang and
+# lock system startup in such situation
+
+if [ ! -f /proc/mdstat ] || ! /bin/egrep -qi "re(cover|sync)|syncing" /proc/mdstat; then
+ if [ -x /sbin/hdparm ]; then
+ for device in {0..40}; do
+ unset MULTIPLE_IO USE_DMA EIDE_32BIT LOOKAHEAD EXTRA_PARAMS
+ if [ -f /etc/sysconfig/harddisk${disk[$device]} ]; then
+ . /etc/sysconfig/harddisk${disk[$device]}
+ HDFLAGS[$device]=
+ if [ -n "$MULTIPLE_IO" ]; then
+ HDFLAGS[$device]="-q -m$MULTIPLE_IO"
+ fi
+ if [ -n "$USE_DMA" ]; then
+ HDFLAGS[$device]="${HDFLAGS[$device]} -q -d$USE_DMA"
+ fi
+ if [ -n "$EIDE_32BIT" ]; then
+ HDFLAGS[$device]="${HDFLAGS[$device]} -q -c$EIDE_32BIT"
+ fi
+ if [ -n "$LOOKAHEAD" ]; then
+ HDFLAGS[$device]="${HDFLAGS[$device]} -q -A$LOOKAHEAD"
+ fi
+ if [ -n "$EXTRA_PARAMS" ]; then
+ HDFLAGS[$device]="${HDFLAGS[$device]} $EXTRA_PARAMS"
+ fi
+ else
+ HDFLAGS[$device]="${HDFLAGS[0]}"
+ fi
+ if [ -e "/proc/ide/${disk[$device]}/media" -o -e "/sys/block/${disk[$device]}/device/vendor" ]; then
+ if [ -e "/proc/ide/${disk[$device]}/media" ]; then
+ hdmedia=`cat /proc/ide/${disk[$device]}/media`
+ else
+ hdmedia=`cat /sys/block/${disk[$device]}/device/vendor`
+ fi
+ if [ "$hdmedia" = "disk" -o "$vendor" = "ATA" -o -f "/etc/sysconfig/harddisk${disk[$device]}" ]; then
+ if [ -n "${HDFLAGS[$device]}" ]; then
+ sleep 2
+ action "Setting hard drive parameters for %s: " ${disk[$device]} /sbin/hdparm ${HDFLAGS[$device]} /dev/${disk[$device]}
+ fi
+ fi
+ fi
+ done
+ fi
+else
+ action "RAID Arrays are resyncing. Skipping hard drive parameters section." /bin/true
+fi
+) &
+
+
+# Adjust symlinks as necessary in /boot to keep system services from
+# spewing messages about mismatched System maps and so on.
+if [ -L /boot/System.map -a -r /boot/System.map-$uname_r -a \
+ ! /boot/System.map -ef /boot/System.map-$uname_r ] ; then
+ ln -s -f System.map-$uname_r /boot/System.map 2>/dev/null
+fi
+if [ ! -e /boot/System.map -a -r /boot/System.map-$uname_r ] ; then
+ ln -s -f System.map-$uname_r /boot/System.map 2>/dev/null
+fi
+
+# Adjust symlinks as necessary in /boot to have the default config
+if [ -L /boot/config -a -r /boot/config-$uname_r ] ; then
+ ln -sf config-$uname_r /boot/config 2>/dev/null
+fi
+if [ ! -e /boot/config -a -r /boot/config-$uname_r ] ; then
+ ln -sf config-$uname_r /boot/config 2>/dev/null
+fi
+
# Now that we have all of our basic modules loaded and the kernel going,
# let's dump the syslog ring somewhere so we can find it later
[ -f /var/log/dmesg ] && mv -f /var/log/dmesg /var/log/dmesg.old
dmesg -s 131072 > /var/log/dmesg
+) &
# create the crash indicator flag to warn on crashes, offer fsck with timeout
touch /.autofsck &> /dev/null
+if [ "$PROMPT" != no ]; then
+ while :; do
+ pid=$(/sbin/pidof getkey)
+ [ -n "$pid" -o -e /var/run/getkey_done ] && break
+ usleep 100000
+ done
+ [ -n "$pid" ] && kill -TERM "$pid" >/dev/null 2>&1
+fi
+} &
if strstr "$cmdline" confirm ; then
touch /var/run/confirm
fi
+if [ "x$SPEEDBOOT" != "xyes" ]; then
+if [ "$PROMPT" != "no" ]; then
+ /sbin/getkey i && touch /var/run/confirm
+ touch /var/run/getkey_done
+fi
+wait
+[ "$PROMPT" != no ] && rm -f /var/run/getkey_done
+fi
+
+if strstr "$cmdline" failsafe; then
+ touch /var/run/failsafe
+fi
+
+if [ -f /var/lock/TMP_1ST ];then
+ if [ -f /etc/init.d/mandrake_firstime ];then
+ /bin/sh /etc/init.d/mandrake_firstime
+ fi
+fi
+
+if [ "x$SPEEDBOOT" = "xyes" ]; then
+ if [ ! -f /.readahead_collect -a -x /sbin/readahead_later ]; then
+ /sbin/readahead_later > /dev/null 2>&1
+ fi
+ wait $RC_PID
+ countdown=10
+ until [ -e /tmp/.X11-unix/X0 -o $countdown -eq 0 ]; do
+ sleep 1; let countdown=$countdown-1;
+ done
+
+
+
+ /sbin/udevadm trigger --action=add --subsystem-nomatch=tty --subsystem-nomatch=block --subsystem-nomatch=mem --subsystem-nomatch=input --subsystem-nomatch=acpi --subsystem-nomatch=rtc --subsystem-nomatch=hid
+ /sbin/udevadm settle --timeout=5 > /dev/null 2>&1
+ /sbin/udevadm control --env=STARTUP=
+ mount -n -t usbfs -o devmode=0664,devgid=43 /proc/bus/usb /proc/bus/usb
+
+ # (anssi) at this point plymouth should have quit, reopen descriptors to
+ # ensure that the output of the rest of this script is seen if the user is
+ # not in X11
+ exec 0<>/proc/self/fd/0 1<>/proc/self/fd/1 2<>/proc/self/fd/2
+fi
+
+if [ -f /etc/init.d/mandrake_everytime ]; then
+ /bin/sh /etc/init.d/mandrake_everytime
+fi
+
+if [ "x$SPEEDBOOT_PROBE" = "xyes" ]; then
+ sed -i -e "/$uname_r .*/d" /var/lib/speedboot/status 2>/dev/null
+ unset SPEEDBOOT_PROBE
+fi
+
+if [ "x$SPEEDBOOT" = "xyes" -a ! -e /tmp/.X11-unix/X0 ]; then
+ /etc/init.d/dm stop
+ grep -q "$uname_r" /var/lib/speedboot/status 2> /dev/null
+ RETVAL=$?
+ if [ $RETVAL -eq 0 ]; then
+ sed -i -e "s/^$uname_r FAILED (first time)/$uname_r FAILED/g" -e "/FAILED/!s/^$uname_r .*/$uname_r FAILED (first time)/g" /var/lib/speedboot/status
+ else
+ echo "$uname_r FAILED (first time)" >> /var/lib/speedboot/status
+ fi
+fi
+
+# system configuration doesn't permit speedboot or speedboot failed, disable it
+if strstr "$SPEEDBOOT" DISABLED ; then
+ grep -q $uname_r /var/lib/speedboot/status 2> /dev/null
+ RETVAL=$?
+ if [ $RETVAL -eq 0 ]; then
+ sed -i -e "s/^$uname_r .*/$uname_r $SPEEDBOOT/g" /var/lib/speedboot/status
+ else
+ echo "$uname_r $SPEEDBOOT" >> /var/lib/speedboot/status
+ fi
+fi
+
+unset SPEEDBOOT
+
+# (pixel) a kind of profile for XF86Config
+# if no XFree=XXX given on kernel command-line, restore XF86Config.standard
+for i in XF86Config XF86Config-4; do
+ if [ -L "/etc/X11/$i" ]; then
+ XFree=`sed -n 's/.*XFree=\(\w*\).*/\1/p' /proc/cmdline`
+ [ -n "$XFree" ] || XFree=standard
+ [ -r "/etc/X11/$i.$XFree" ] && ln -sf "$i.$XFree" "/etc/X11/$i"
+ fi
+done
# Let rhgb know that we're leaving rc.sysinit
if [ -x /usr/bin/plymouth ]; then
/usr/bin/plymouth --sysinit
fi
+# remove this file at the very end, for speedboot
+rm -f /dev/.in_sysinit
+